Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 2528)
@@ -10,5 +10,4 @@
    !!----------------------------------------------------------------------
    !!   'key_trdvor'   : momentum trend diagnostics
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trd_vor      : momentum trends averaged over the depth
@@ -39,21 +38,16 @@
    PUBLIC   trd_vor_init   ! routine called by opa.F90
 
-   INTEGER ::                &
-      nh_t, nmoydpvor  ,     &
-      nidvor, nhoridvor,     &
-      ndexvor1(jpi*jpj),     &
-      ndimvor1, icount,      &
-      idebug                    ! (0/1) set it to 1 in case of problem to have more print
-
-   REAL(wp), DIMENSION(jpi,jpj) ::  &
-     vor_avr    ,     &  ! average
-     vor_avrb   ,     &  ! before vorticity (kt-1)
-     vor_avrbb  ,     &  ! vorticity at begining of the nwrite-1 timestep averaging period
-     vor_avrbn  ,     &  ! after vorticity at time step after the
-     rotot      ,     &  ! begining of the NWRITE-1 timesteps
-     vor_avrtot ,     &
-     vor_avrres
-
-   REAL(wp), DIMENSION(jpi,jpj,jpltot_vor)::   vortrd  !: curl of trends
+   INTEGER ::   nh_t, nmoydpvor, nidvor, nhoridvor, ndexvor1(jpi*jpj), ndimvor1, icount   ! needs for IOIPSL output
+   INTEGER ::   ndebug     ! (0/1) set it to 1 in case of problem to have more print
+
+   REAL(wp), DIMENSION(jpi,jpj) ::   vor_avr      ! average
+   REAL(wp), DIMENSION(jpi,jpj) ::   vor_avrb     ! before vorticity (kt-1)
+   REAL(wp), DIMENSION(jpi,jpj) ::   vor_avrbb    ! vorticity at begining of the nwrite-1 timestep averaging period
+   REAL(wp), DIMENSION(jpi,jpj) ::   vor_avrbn    ! after vorticity at time step after the
+   REAL(wp), DIMENSION(jpi,jpj) ::   rotot        ! begining of the NWRITE-1 timesteps
+   REAL(wp), DIMENSION(jpi,jpj) ::   vor_avrtot   !
+   REAL(wp), DIMENSION(jpi,jpj) ::   vor_avrres   !
+
+   REAL(wp), DIMENSION(jpi,jpj,jpltot_vor) ::   vortrd  ! curl of trends
          
    CHARACTER(len=12) ::   cvort
@@ -64,9 +58,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-  
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -76,22 +69,9 @@
       !!
       !! ** Purpose :   computation of vertically integrated vorticity budgets
-      !!      from ocean surface down to control surface (NetCDF output)
-      !!
-      !! ** Method/usage :
-      !!      integration done over nwrite-1 time steps
-      !!
-      !!
-      !! ** Action :
-      !!            /comvor/   :
-      !!                         vor_avr          average
-      !!                         vor_avrb         vorticity at kt-1
-      !!                         vor_avrbb        vorticity at begining of the NWRITE-1
-      !!                                          time steps averaging period
-      !!                         vor_avrbn         vorticity at time step after the
-      !!                                          begining of the NWRITE-1 time
-      !!                                          steps averaging period
-      !!
-      !!                 trends :
-      !!
+      !!              from ocean surface down to control surface (NetCDF output)
+      !!
+      !! ** Method/usage :   integration done over nwrite-1 time steps
+      !!
+      !! ** Action :   trends :
       !!                  vortrd (,, 1) = Pressure Gradient Trend
       !!                  vortrd (,, 2) = KE Gradient Trend
@@ -104,5 +84,5 @@
       !!                  vortrd (,, 9) = Beta V
       !!                  vortrd (,,10) = forcing term
-      !!		  vortrd (,,11) = bottom friction term
+      !!		              vortrd (,,11) = bottom friction term
       !!                  rotot(,) : total cumulative trends over nwrite-1 time steps
       !!                  vor_avrtot(,) : first membre of vrticity equation
@@ -110,21 +90,19 @@
       !!
       !!      trends output in netCDF format using ioipsl
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   &
-         putrdvor,                         &  ! u vorticity trend 
-         pvtrdvor                             ! v vorticity trend
-      !!
-      INTEGER ::   ji, jj
-      INTEGER ::   ikbu, ikbum1, ikbv, ikbvm1
+      !!----------------------------------------------------------------------
+      INTEGER                     , INTENT(in   ) ::   ktrd       ! ocean trend index
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   putrdvor   ! u vorticity trend 
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   pvtrdvor   ! v vorticity trend
+      !!
+      INTEGER ::   ji, jj       ! dummy loop indices
+      INTEGER ::   ikbu, ikbv   ! local integers
       REAL(wp), DIMENSION(jpi,jpj) ::   zudpvor, zvdpvor   ! total cmulative trends
       !!----------------------------------------------------------------------
 
       ! Initialization
-      zudpvor(:,:) = 0.e0
-      zvdpvor(:,:) = 0.e0
-
-      CALL lbc_lnk( putrdvor,  'U' , -1. )
+      zudpvor(:,:) = 0._wp
+      zvdpvor(:,:) = 0._wp
+      !
+      CALL lbc_lnk( putrdvor,  'U' , -1. )         ! lateral boundary condition on input momentum trends
       CALL lbc_lnk( pvtrdvor,  'V' , -1. )
 
@@ -134,24 +112,19 @@
 
       SELECT CASE (ktrd) 
-
+      !
       CASE (jpvor_bfr)        ! bottom friction
-
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1 
-               ikbu   = min( mbathy(ji+1,jj), mbathy(ji,jj) )
-               ikbum1 = max( ikbu-1, 1 )
-               ikbv   = min( mbathy(ji,jj+1), mbathy(ji,jj) )
-               ikbvm1 = max( ikbv-1, 1 )
-            
-               zudpvor(ji,jj) = putrdvor(ji,jj) * fse3u(ji,jj,ikbum1) * e1u(ji,jj) * umask(ji,jj,ikbum1)
-               zvdpvor(ji,jj) = pvtrdvor(ji,jj) * fse3v(ji,jj,ikbvm1) * e2v(ji,jj) * vmask(ji,jj,ikbvm1)
+               ikbu = mbkv(ji,jj)
+               ikbv = mbkv(ji,jj)            
+               zudpvor(ji,jj) = putrdvor(ji,jj) * fse3u(ji,jj,ikbu) * e1u(ji,jj) * umask(ji,jj,ikbu)
+               zvdpvor(ji,jj) = pvtrdvor(ji,jj) * fse3v(ji,jj,ikbv) * e2v(ji,jj) * vmask(ji,jj,ikbv)
             END DO
          END DO
-
+         !
       CASE (jpvor_swf)        ! wind stress
-
          zudpvor(:,:) = putrdvor(:,:) * fse3u(:,:,1) * e1u(:,:) * umask(:,:,1)
          zvdpvor(:,:) = pvtrdvor(:,:) * fse3v(:,:,1) * e2v(:,:) * vmask(:,:,1)
-
+         !
       END SELECT
 
@@ -163,14 +136,11 @@
       DO ji=1,jpim1
          DO jj=1,jpjm1
-            vortrd(ji,jj,ktrd) = ( zvdpvor(ji+1,jj) - zvdpvor(ji,jj)        &
-                 &                - ( zudpvor(ji,jj+1) - zudpvor(ji,jj) ) ) &
-                 &               / ( e1f(ji,jj) * e2f(ji,jj) )
+            vortrd(ji,jj,ktrd) = (    zvdpvor(ji+1,jj) - zvdpvor(ji,jj)       &
+                 &                - ( zudpvor(ji,jj+1) - zudpvor(ji,jj) )   ) / ( e1f(ji,jj) * e2f(ji,jj) )
          END DO
       END DO
-
-      ! Surface mask
-      vortrd(:,:,ktrd) = vortrd(:,:,ktrd) * fmask(:,:,1)
-
-      IF( idebug /= 0 ) THEN
+      vortrd(:,:,ktrd) = vortrd(:,:,ktrd) * fmask(:,:,1)      ! Surface mask
+
+      IF( ndebug /= 0 ) THEN
          IF(lwp) WRITE(numout,*) ' debuging trd_vor_zint: I done'
          CALL FLUSH(numout)
@@ -185,22 +155,9 @@
       !!
       !! ** Purpose :   computation of vertically integrated vorticity budgets
-      !!      from ocean surface down to control surface (NetCDF output)
-      !!
-      !! ** Method/usage :
-      !!      integration done over nwrite-1 time steps
-      !!
-      !!
-      !! ** Action :
-      !!            /comvor/   :
-      !!                         vor_avr          average
-      !!                         vor_avrb         vorticity at kt-1
-      !!                         vor_avrbb        vorticity at begining of the NWRITE-1
-      !!                                          time steps averaging period
-      !!                         vor_avrbn         vorticity at time step after the
-      !!                                          begining of the NWRITE-1 time
-      !!                                          steps averaging period
-      !!
-      !!                 trends :
-      !!
+      !!              from ocean surface down to control surface (NetCDF output)
+      !!
+      !! ** Method/usage :   integration done over nwrite-1 time steps
+      !!
+      !! ** Action :     trends :
       !!                  vortrd (,,1) = Pressure Gradient Trend
       !!                  vortrd (,,2) = KE Gradient Trend
@@ -219,32 +176,26 @@
       !!
       !!      trends output in netCDF format using ioipsl
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
-         putrdvor,                         &  ! u vorticity trend 
-         pvtrdvor                             ! v vorticity trend
+      !!----------------------------------------------------------------------
+      INTEGER                         , INTENT(in   ) ::   ktrd       ! ocean trend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   putrdvor   ! u vorticity trend 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pvtrdvor   ! v vorticity trend
       !!
       INTEGER ::   ji, jj, jk
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zubet,                         &  ! u Beta.V case
-         zvbet,                         &  ! v Beta.V case
-         zudpvor,                       &  ! total cmulative trends
-         zvdpvor                           !   "      "        "
+      REAL(wp), DIMENSION(jpi,jpj) ::   zubet  , zvbet     ! Beta.V 
+      REAL(wp), DIMENSION(jpi,jpj) ::   zudpvor, zvdpvor   ! total cmulative trends
       !!----------------------------------------------------------------------
      
       ! Initialization
-      zubet(:,:) = 0.e0
-      zvbet(:,:) = 0.e0
-      zudpvor(:,:) = 0.e0
-      zvdpvor(:,:) = 0.e0
+      zubet  (:,:) = 0._wp
+      zvbet  (:,:) = 0._wp
+      zudpvor(:,:) = 0._wp
+      zvdpvor(:,:) = 0._wp
+      !
+      CALL lbc_lnk( putrdvor, 'U' , -1. )         ! lateral boundary condition on input momentum trends
+      CALL lbc_lnk( pvtrdvor, 'V' , -1. )
 
       !  =====================================
       !  I vertical integration of 3D trends
       !  =====================================
-
-      CALL lbc_lnk( putrdvor, 'U' , -1. )
-      CALL lbc_lnk( pvtrdvor, 'V' , -1. )
-
       ! putrdvor and pvtrdvor terms
       DO jk = 1,jpk
@@ -267,7 +218,6 @@
       DO ji=1,jpim1
          DO jj=1,jpjm1
-            vortrd(ji,jj,ktrd) = (  zvdpvor(ji+1,jj) - zvdpvor(ji,jj) -   &
-                 &                ( zudpvor(ji,jj+1) - zudpvor(ji,jj) ) ) &
-                 &               / ( e1f(ji,jj) * e2f(ji,jj) )
+            vortrd(ji,jj,ktrd) = (    zvdpvor(ji+1,jj) - zvdpvor(ji,jj)     &
+               &                  - ( zudpvor(ji,jj+1) - zudpvor(ji,jj) ) ) / ( e1f(ji,jj) * e2f(ji,jj) )
          END DO
       END DO
@@ -281,7 +231,6 @@
          DO ji=1,jpim1
             DO jj=1,jpjm1
-               vortrd(ji,jj,jpvor_bev) = (  zvbet(ji+1,jj) - zvbet(ji,jj) -   &
-                    &                    ( zubet(ji,jj+1) - zubet(ji,jj) ) ) &
-                    &                   / ( e1f(ji,jj) * e2f(ji,jj) )
+               vortrd(ji,jj,jpvor_bev) = (    zvbet(ji+1,jj) - zvbet(ji,jj)     &
+                  &                       - ( zubet(ji,jj+1) - zubet(ji,jj) ) ) / ( e1f(ji,jj) * e2f(ji,jj) )
             END DO
          END DO
@@ -294,5 +243,5 @@
       ENDIF
    
-      IF( idebug /= 0 ) THEN
+      IF( ndebug /= 0 ) THEN
          IF(lwp) WRITE(numout,*) ' debuging trd_vor_zint: I done'
          CALL FLUSH(numout)
@@ -309,9 +258,10 @@
       !!               and make outputs (NetCDF or DIMG format)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
-      !!
-      INTEGER  ::   ji, jj, jk, jl, it, itmod
-      REAL(wp) ::   zmean
-      REAL(wp), DIMENSION(jpi,jpj) ::   zun, zvn
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk, jl   ! dummy loop indices
+      INTEGER  ::   it, itmod        ! local integers
+      REAL(wp) ::   zmean            ! local scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zun, zvn   ! 2D workspace
       !!----------------------------------------------------------------------
 
@@ -324,9 +274,7 @@
       ! ---------------------------------------------------
 
-      IF( kt > nit000 ) THEN
-         vor_avrb(:,:) = vor_avr(:,:)
-      ENDIF
-
-       IF( idebug /= 0 ) THEN
+      IF( kt > nit000 )   vor_avrb(:,:) = vor_avr(:,:)
+
+      IF( ndebug /= 0 ) THEN
           WRITE(numout,*) ' debuging trd_vor: I.1 done '
           CALL FLUSH(numout)
@@ -336,30 +284,28 @@
       !  ----------------------------------
 
-      vor_avr(:,:) = 0.
-      zun(:,:)=0
-      zvn(:,:)=0
-      vor_avrtot(:,:)=0
-      vor_avrres(:,:)=0
+      vor_avr   (:,:) = 0._wp
+      zun       (:,:) = 0._wp
+      zvn       (:,:) = 0._wp
+      vor_avrtot(:,:) = 0._wp
+      vor_avrres(:,:) = 0._wp
       
       ! Vertically averaged velocity
       DO jk = 1, jpk - 1
-         zun(:,:)=zun(:,:) + e1u(:,:)*un(:,:,jk)*fse3u(:,:,jk)
-         zvn(:,:)=zvn(:,:) + e2v(:,:)*vn(:,:,jk)*fse3v(:,:,jk)
+         zun(:,:) = zun(:,:) + e1u(:,:) * un(:,:,jk) * fse3u(:,:,jk)
+         zvn(:,:) = zvn(:,:) + e2v(:,:) * vn(:,:,jk) * fse3v(:,:,jk)
       END DO
  
-      zun(:,:)=zun(:,:)*hur(:,:)
-      zvn(:,:)=zvn(:,:)*hvr(:,:)
+      zun(:,:) = zun(:,:) * hur(:,:)
+      zvn(:,:) = zvn(:,:) * hvr(:,:)
 
       ! Curl
       DO ji=1,jpim1
          DO jj=1,jpjm1
-            vor_avr(ji,jj) = ((zvn(ji+1,jj)-zvn(ji,jj))-   &
-                              (zun(ji,jj+1)-zun(ji,jj)))   &
-                             /( e1f(ji,jj) * e2f(ji,jj) )
-            vor_avr(ji,jj) = vor_avr(ji,jj)*fmask(ji,jj,1)
+            vor_avr(ji,jj) = (  ( zvn(ji+1,jj) - zvn(ji,jj) )    &
+               &              - ( zun(ji,jj+1) - zun(ji,jj) ) ) / ( e1f(ji,jj) * e2f(ji,jj) ) * fmask(ji,jj,1)
          END DO
       END DO
       
-      IF(idebug /= 0) THEN
+      IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor: I.2 done'
          CALL FLUSH(numout)
@@ -377,5 +323,5 @@
       ENDIF
 
-      IF( idebug /= 0 ) THEN
+      IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor: I1.1 done'
          CALL FLUSH(numout)
@@ -395,5 +341,5 @@
       ENDIF
 
-      IF( idebug /= 0 ) THEN
+      IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor: II.2 done'
          CALL FLUSH(numout)
@@ -405,5 +351,5 @@
 
       ! define time axis
-      it = kt
+      it    = kt
       itmod = kt - nit000 + 1
 
@@ -412,10 +358,8 @@
          ! III.1 compute total trend
          ! ------------------------
-         zmean = float(nmoydpvor)
-
-         vor_avrtot(:,:) = ( vor_avr(:,:) - vor_avrbn(:,:) + vor_avrb(:,:) - &
-                             vor_avrbb(:,:) ) /  (zmean * 2. * rdt)
-
-         IF( idebug /= 0 ) THEN
+         zmean = 1._wp / (  REAL( nmoydpvor, wp ) * 2._wp * rdt  )
+         vor_avrtot(:,:) = (  vor_avr(:,:) - vor_avrbn(:,:) + vor_avrb(:,:) - vor_avrbb(:,:) ) * zmean
+
+         IF( ndebug /= 0 ) THEN
              WRITE(numout,*) ' zmean = ',zmean
              WRITE(numout,*) ' debuging trd_vor: III.1 done'
@@ -425,4 +369,5 @@
          ! III.2 compute residual
          ! ---------------------
+         zmean = 1._wp / REAL( nmoydpvor, wp )
          vor_avrres(:,:) = vor_avrtot(:,:) - rotot(:,:) / zmean
 
@@ -431,5 +376,5 @@
          CALL lbc_lnk( vor_avrres, 'F', 1. )
 
-         IF( idebug /= 0 ) THEN
+         IF( ndebug /= 0 ) THEN
             WRITE(numout,*) ' debuging trd_vor: III.2 done'
             CALL FLUSH(numout)
@@ -439,13 +384,13 @@
          ! ------------------------------
          vor_avrbb(:,:) = vor_avrb(:,:)
-         vor_avrbn(:,:) = vor_avr(:,:)
-
-         IF( idebug /= 0 ) THEN
+         vor_avrbn(:,:) = vor_avr (:,:)
+
+         IF( ndebug /= 0 ) THEN
             WRITE(numout,*) ' debuging trd_vor: III.3 done'
             CALL FLUSH(numout)
          ENDIF
-
-         nmoydpvor=0
-
+         !
+         nmoydpvor = 0
+         !
       ENDIF
 
@@ -475,5 +420,5 @@
          CALL histwrite( nidvor,"sovorgap",it,vor_avrres    ,ndimvor1,ndexvor1) ! gap between 1st and 2 nd mbre
          !
-         IF( idebug /= 0 ) THEN
+         IF( ndebug /= 0 ) THEN
             WRITE(numout,*) ' debuging trd_vor: III.4 done'
             CALL FLUSH(numout)
@@ -508,5 +453,5 @@
 
       ! Open specifier
-      idebug = 0      ! set it to 1 in case of problem to have more Print
+      ndebug = 0      ! set it to 1 in case of problem to have more Print
 
       IF(lwp) THEN
@@ -528,5 +473,5 @@
       vor_avrres(:,:)=0
 
-      IF( idebug /= 0 ) THEN
+      IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor_init: I. done'
          CALL FLUSH(numout)
@@ -568,5 +513,5 @@
       IF(lwp) WRITE(numout,*) ' Name of NETCDF file ', clhstnam
       CALL histbeg( clhstnam, jpi, glamf, jpj, gphif,1, jpi,   &  ! Horizontal grid : glamt and gphit
-         &          1, jpj, nit000-1, zjulian, rdt, nh_t, nidvor, domain_id=nidom )
+         &          1, jpj, nit000-1, zjulian, rdt, nh_t, nidvor, domain_id=nidom, snc4chunks=snc4set )
       CALL wheneq( jpi*jpj, fmask, 1, 1., ndexvor1, ndimvor1 )    ! surface
 
@@ -598,7 +543,7 @@
       CALL histdef( nidvor, "sovorgap", cvort//"gap", "s-2",             & ! gap between 1st and 2 nd mbre
          &          jpi,jpj,nh_t,1,1,1,-99,32,clop,zsto,zout)
-      CALL histend( nidvor )
-
-      IF( idebug /= 0 ) THEN
+      CALL histend( nidvor, snc4set )
+
+      IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor_init: II. done'
          CALL FLUSH(numout)
@@ -621,14 +566,10 @@
       REAL, DIMENSION(:,:), INTENT( inout ) ::   putrdvor, pvtrdvor
       INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-      WRITE(*,*) 'trd_vor_zint_2d: You should not have seen this print! error?', putrdvor(1,1)
-      WRITE(*,*) '  "      "     : You should not have seen this print! error?', pvtrdvor(1,1)
-      WRITE(*,*) '  "      "     : You should not have seen this print! error?', ktrd
+      WRITE(*,*) 'trd_vor_zint_2d: You should not have seen this print! error?', putrdvor(1,1), pvtrdvor(1,1), ktrd
    END SUBROUTINE trd_vor_zint_2d
    SUBROUTINE trd_vor_zint_3d( putrdvor, pvtrdvor, ktrd )
       REAL, DIMENSION(:,:,:), INTENT( inout ) ::   putrdvor, pvtrdvor
       INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-      WRITE(*,*) 'trd_vor_zint_3d: You should not have seen this print! error?', putrdvor(1,1,1)
-      WRITE(*,*) '  "      "     : You should not have seen this print! error?', pvtrdvor(1,1,1)
-      WRITE(*,*) '  "      "     : You should not have seen this print! error?', ktrd
+      WRITE(*,*) 'trd_vor_zint_3d: You should not have seen this print! error?', putrdvor(1,1,1), pvtrdvor(1,1,1), ktrd
    END SUBROUTINE trd_vor_zint_3d
    SUBROUTINE trd_vor_init              ! Empty routine
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor_oce.F90	(revision 2528)
@@ -34,7 +34,7 @@
 
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trdvor_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90	(revision 2528)
@@ -33,13 +33,14 @@
 
 
-   REAL(wp), PUBLIC, DIMENSION        (jpk) ::   avmb, avtb   !: background profile of avm and avt
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   avtb_2d      !: set in tke_init, for other modif than ice
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   avmu, avmv   !: vertical viscosity coeff. at uw- & vw-points   [m2/s]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   avm , avt    !: vertical viscosity & diffusivity coeff. at  w-point   [m2/s]
+   REAL(wp), PUBLIC, DIMENSION        (jpk) ::   avmb , avtb    !: background profile of avm and avt
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   avtb_2d        !: set in tke_init, for other modif than ice
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   bfrua, bfrva   !: Bottom friction coefficients set in zdfbfr
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   avmu , avmv    !: vertical viscosity coef at uw- & vw-pts        [m2/s]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   avm  , avt     !: vertical viscosity & diffusivity coef at w-pt  [m2/s]
  
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE zdf_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfbfr.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfbfr.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfbfr.F90	(revision 2528)
@@ -7,4 +7,5 @@
    !!   NEMO     1.0  ! 2002-06  (G. Madec)  F90: Free form and module
    !!            3.2  ! 2009-09  (A.C.Coward)  Correction to include barotropic contribution
+   !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 
@@ -12,6 +13,5 @@
    !!   zdf_bfr      : update momentum Kz at the ocean bottom due to the type of bottom friction chosen
    !!   zdf_bfr_init : read in namelist and control the bottom friction parameters.
-   !!   zdf_bfr_2d   : read in namelist and control the bottom friction
-   !!                  parameters.
+   !!   zdf_bfr_2d   : read in namelist and control the bottom friction parameters.
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
@@ -26,8 +26,7 @@
    PRIVATE
 
-   PUBLIC   zdf_bfr    ! called by step.F90
+   PUBLIC   zdf_bfr         ! called by step.F90
+   PUBLIC   zdf_bfr_init    ! called by opa.F90
    
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   bfrua , bfrva   !: Bottom friction coefficients set in zdfbfr
-
    !                                    !!* Namelist nambfr: bottom friction namelist *
    INTEGER  ::   nn_bfr    = 0           ! = 0/1/2/3 type of bottom friction 
@@ -35,5 +34,5 @@
    REAL(wp) ::   rn_bfri2  = 1.0e-3_wp   ! bottom drag coefficient (non linear case)
    REAL(wp) ::   rn_bfeb2  = 2.5e-3_wp   ! background bottom turbulent kinetic energy  [m2/s2]
-   REAL(wp) ::   rn_bfrien = 30_wp       ! local factor to enhance coefficient bfri
+   REAL(wp) ::   rn_bfrien = 30._wp      ! local factor to enhance coefficient bfri
    LOGICAL  ::   ln_bfr2d  = .false.     ! logical switch for 2D enhancement
    
@@ -41,11 +40,11 @@
 
    !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -68,12 +67,8 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
-      INTEGER  ::   ji, jj         ! dummy loop indices
-      INTEGER  ::   ikbu, ikbum1   ! temporary integers
-      INTEGER  ::   ikbv, ikbvm1   !    -          -
+      INTEGER  ::   ji, jj       ! dummy loop indices
+      INTEGER  ::   ikbu, ikbv   ! local integers
       REAL(wp) ::   zvu, zuv, zecu, zecv   ! temporary scalars
       !!----------------------------------------------------------------------
-
-
-      IF( kt == nit000 )   CALL zdf_bfr_init   ! initialisation
 
       IF( nn_bfr == 2 ) THEN                 ! quadratic botton friction
@@ -93,19 +88,17 @@
             DO ji = 2, jpim1
 # endif
-               ikbu   = MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) )
-               ikbv   = MIN( mbathy(ji  ,jj+1), mbathy(ji,jj) )
-               ikbum1 = MAX( ikbu-1, 1 )
-               ikbvm1 = MAX( ikbv-1, 1 )
+               ikbu = mbku(ji,jj)         ! ocean bottom level at u- and v-points 
+               ikbv = mbkv(ji,jj)         ! (deepest ocean u- and v-points)
                !
-               zvu  = 0.25 * (  vn(ji,jj  ,ikbum1) + vn(ji+1,jj  ,ikbum1)     &
-                  &           + vn(ji,jj-1,ikbum1) + vn(ji+1,jj-1,ikbum1)  )
-               zuv  = 0.25 * (  un(ji,jj  ,ikbvm1) + un(ji-1,jj  ,ikbvm1)     &
-                  &           + un(ji,jj+1,ikbvm1) + un(ji-1,jj+1,ikbvm1)  )
+               zvu  = 0.25 * (  vn(ji,jj  ,ikbu) + vn(ji+1,jj  ,ikbu)     &
+                  &           + vn(ji,jj-1,ikbu) + vn(ji+1,jj-1,ikbu)  )
+               zuv  = 0.25 * (  un(ji,jj  ,ikbv) + un(ji-1,jj  ,ikbv)     &
+                  &           + un(ji,jj+1,ikbv) + un(ji-1,jj+1,ikbv)  )
                !
-               zecu = SQRT(  un(ji,jj,ikbum1) * un(ji,jj,ikbum1) + zvu*zvu + rn_bfeb2  )
-               zecv = SQRT(  vn(ji,jj,ikbvm1) * vn(ji,jj,ikbvm1) + zuv*zuv + rn_bfeb2  )
+               zecu = SQRT(  un(ji,jj,ikbu) * un(ji,jj,ikbu) + zvu*zvu + rn_bfeb2  )
+               zecv = SQRT(  vn(ji,jj,ikbv) * vn(ji,jj,ikbv) + zuv*zuv + rn_bfeb2  )
                !
-               bfrua(ji,jj) = - 0.5 * ( bfrcoef2d(ji,jj) + bfrcoef2d(ji+1,jj  ) ) * zecu 
-               bfrva(ji,jj) = - 0.5 * ( bfrcoef2d(ji,jj) + bfrcoef2d(ji  ,jj+1) ) * zecv
+               bfrua(ji,jj) = - 0.5_wp * ( bfrcoef2d(ji,jj) + bfrcoef2d(ji+1,jj  ) ) * zecu 
+               bfrva(ji,jj) = - 0.5_wp * ( bfrcoef2d(ji,jj) + bfrcoef2d(ji  ,jj+1) ) * zecv
             END DO
          END DO
@@ -131,10 +124,10 @@
       USE iom   ! I/O module for ehanced bottom friction file
       !!
-      INTEGER ::   inum                         ! logical unit for enhanced bottom friction file
-      INTEGER ::   ji, jj                       ! dummy loop indexes
-      INTEGER ::   ikbu, ikbv, ikbum1, ikbvm1   ! temporary integers
-      INTEGER ::   ictu, ictv                   !    -          -
-      REAL(wp) ::  zminbfr, zmaxbfr             ! temporary scalars
-      REAL(wp) ::  zfru, zfrv                   !    -         -
+      INTEGER ::   inum         ! logical unit for enhanced bottom friction file
+      INTEGER ::   ji, jj       ! dummy loop indexes
+      INTEGER ::   ikbu, ikbv   ! temporary integers
+      INTEGER ::   ictu, ictv   !    -          -
+      REAL(wp) ::  zminbfr, zmaxbfr   ! temporary scalars
+      REAL(wp) ::  zfru, zfrv         !    -         -
       !!
       NAMELIST/nambfr/ nn_bfr, rn_bfri1, rn_bfri2, rn_bfeb2, ln_bfr2d, rn_bfrien
@@ -218,14 +211,12 @@
          DO ji = 2, jpim1
 #  endif
-             ikbu = MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) )
-             ikbv = MIN( mbathy(ji  ,jj+1), mbathy(ji,jj) )
-             ikbum1 = MAX( ikbu-1, 1 )
-             ikbvm1 = MAX( ikbv-1, 1 )
-             zfru = 0.5 * fse3u(ji,jj,ikbum1) / rdt
-             zfrv = 0.5 * fse3v(ji,jj,ikbvm1) / rdt
+             ikbu = mbku(ji,jj)       ! deepest ocean level at u- and v-points
+             ikbv = mbkv(ji,jj)
+             zfru = 0.5 * fse3u(ji,jj,ikbu) / rdt
+             zfrv = 0.5 * fse3v(ji,jj,ikbv) / rdt
              IF( ABS( bfrcoef2d(ji,jj) ) > zfru ) THEN
                 IF( ln_ctl ) THEN
-                   WRITE(numout,*) 'BFR ',narea,nimpp+ji,njmpp+jj,ikbu
-                   WRITE(numout,*) 'BFR ',ABS( bfrcoef2d(ji,jj) ), zfru
+                   WRITE(numout,*) 'BFR ', narea, nimpp+ji, njmpp+jj, ikbu
+                   WRITE(numout,*) 'BFR ', ABS( bfrcoef2d(ji,jj) ), zfru
                 ENDIF
                 ictu = ictu + 1
@@ -248,5 +239,5 @@
          CALL mpp_max( zmaxbfr )
       ENDIF
-      IF( lwp .AND. ictu + ictv .GT. 0 ) THEN
+      IF( lwp .AND. ictu + ictv > 0 ) THEN
          WRITE(numout,*) ' Bottom friction stability check failed at ', ictu, ' U-points '
          WRITE(numout,*) ' Bottom friction stability check failed at ', ictv, ' V-points '
